
class Slider
{
  PVector _p1;
  PVector _p2;

  int     _h;
  float   _pos;
  boolean _active = false;
  
  Slider(int x,int y,int w,int h,float pos)
  {   
    _p1 = new PVector(x,y + h *.5);
    _p2 = new PVector(x+w,y + h *.5);
    
    _h = h;
    
    _pos = pos;
    if(_pos > 1.0)
      _pos = 1.0;
    else if(_pos < 0.0)
      _pos = 0.0;
  }
  
  float pos()
  {
    return _pos;
  }

  boolean isHit(int x,int y)
  {
    if(x > _p1.x && x < _p2.x &&
       y > _p1.y - 5 && y < _p1.y + 5)
      return true;
    else
      return false;
  }
  

  void draw()
  {
    pushStyle();
     drawSlider();
     drawKnob();
    popStyle();
  } 
  
  void drawSlider()
  {
    noFill();
    stroke(0);
    strokeJoin(BEVEL);  
    rect(_p1.x-8, _p1.y-10, _p2.x-_p1.x+16, 20, 10);
    stroke(255);
    rect(_p1.x-7, _p1.y-9, _p2.x-_p1.x+14, 18, 9); 
  }
  
  void drawKnob()
  {
    if(_p1.y == 52)  
      fill(255,200,200);
    else if(_p1.y == 85)
      fill(200,255,200);
    else if(_p1.y == 118)
      fill(200,200,255);
      
    stroke(1);
      
    PVector dir = PVector.sub(_p2,_p1);
    PVector pos = PVector.add( _p1 , PVector.mult(dir,_pos));
    
    ellipse(pos.x, pos.y, 18, 18); 

  }
  
  void mousePos(int x,int y,boolean pressed)
  {
    if(pressed)
    {
      if(isHit(x,y) || _active)
      {  // move knob
        PVector dir = PVector.sub(_p2,_p1);
        
        if(x >= _p1.x && x <= _p2.x)
           _pos = 1.0 / dir.mag() * (x - _p1.x);
         
        _active = true;
      }
    }
    else
    {  
        _active = false;    
    }
  }
  
}
