
class vSlider
{
  PVector _p1;
  PVector _p2;
  int     _w;
  int     _h;
  float   _pos;
  boolean _active = false;
  
  vSlider(int x,int y,int w,int h,float pos)
  {   
    _p1 = new PVector(x,y);
    _p2 = new PVector(x,y + h);
    
    _w = w;
    
    _pos = pos;
    if(_pos > 1.0)
      _pos = 1.0;
    else if(_pos < 0.0)
      _pos = 0.0;
  }
  
  float pos()
  {
    return _pos;
  }

  boolean isHit(int x,int y)
  {
    if(x > _p1.x - 5 && x < _p2.x + 5 &&
       y > _p1.y && y < _p2.y)
      return true;
    else
      return false;
  }
  

  void draw()
  {
    pushStyle();
     drawSlider();
     drawKnob();
    popStyle();
  } 
  
  void drawSlider()
  {
    noFill();
    stroke(0);
    strokeJoin(BEVEL);
    rect(_p1.x-10, _p1.y-8, 20, _p2.y-_p1.y+16, 10);
    stroke(255);
    rect(_p1.x-9, _p1.y-7, 18, _p2.y-_p1.y+14, 9);  
  }
  
  void drawKnob()
  {
    fill(200);
    stroke(1);
    
    PVector dir = PVector.sub(_p2,_p1);
    PVector pos = PVector.add( _p1 , PVector.mult(dir,_pos));

    ellipse(pos.x, pos.y, 18, 18); 

  }
  
  
  void mousePos(int x,int y,boolean pressed)
  {
    if(pressed)
    {
      if(isHit(x,y) || _active)
      {  // move knob
        PVector dir = PVector.sub(_p2,_p1);
        
        if(y >= _p1.y && y <= _p2.y)
          _pos = 1.0 / dir.mag() * (y - _p1.y);
        
        _active = true;
      }
    }
    else
    {  
      _active = false;    
    }
  }
  
}
